# Vue Integration

> Install and configure @toolbox-web/grid-vue — feature props, slot renderers, editors, composables, and event handling.

The `@toolbox-web/grid-vue` package provides Vue 3 integration for the `<tbw-grid>` data grid component.

:::note[Where to find feature docs]
This page covers Vue-specific setup and APIs (feature props, composables, slot renderers). Core grid features and plugins — cell renderers, editors, events, master-detail, sorting, filtering, selection, etc. — are documented on the [Core](/grid/core.md) and [Plugins](/grid/plugins.md) pages, each with a Vue tab and runnable demos.
:::

## Compatibility

| Vue version | Support level |
| ----------- | ------------- |
| 3.5+        | **Tested** — used in demos and CI |
| 3.3 – 3.4   | Supported (minimum peer dependency) |
| &lt; 3.3    | Not supported |
| Vue 2       | Not supported — adapter requires Vue 3 Composition API |

## Installation

#### npm

  ```bash
  npm install @toolbox-web/grid @toolbox-web/grid-vue
  ```

#### yarn

  ```bash
  yarn add @toolbox-web/grid @toolbox-web/grid-vue
  ```

#### pnpm

  ```bash
  pnpm add @toolbox-web/grid @toolbox-web/grid-vue
  ```

#### bun

  ```bash
  bun add @toolbox-web/grid @toolbox-web/grid-vue
  ```

## Setup

Register the grid web component and configure Vue to recognize custom elements:

```typescript
// main.ts
import '@toolbox-web/grid';

// Enable features via side-effect imports
// Only import the features you use - this keeps your bundle small!
import '@toolbox-web/grid-vue/features/selection';
import '@toolbox-web/grid-vue/features/editing';
import '@toolbox-web/grid-vue/features/multi-sort';
import '@toolbox-web/grid-vue/features/filtering';
```

**Important**: Configure Vue to treat `tbw-*` tags as custom elements in your `vite.config.ts`:

```typescript
// vite.config.ts
import vue from '@vitejs/plugin-vue';
import { defineConfig } from 'vite';

export default defineConfig({
  plugins: [
    vue({
      template: {
        compilerOptions: {
          // Tell Vue that tbw-* tags are web components
          isCustomElement: (tag) => tag.startsWith('tbw-'),
        },
      },
    }),
  ],
});
```

## Basic Usage

The simplest way to use the grid is with the `TbwGrid` component and feature props:

```html
<script setup lang="ts">
// Enable features you use
import '@toolbox-web/grid-vue/features/selection';
import '@toolbox-web/grid-vue/features/editing';
import '@toolbox-web/grid-vue/features/multi-sort';
import '@toolbox-web/grid-vue/features/filtering';

import { TbwGrid } from '@toolbox-web/grid-vue';
import type { ColumnConfig } from '@toolbox-web/grid';
import { ref } from 'vue';

interface Employee {
  id: number;
  name: string;
  department: string;
  salary: number;
}

const employees = ref<Employee[]>([
  { id: 1, name: 'Alice', department: 'Engineering', salary: 95000 },
  { id: 2, name: 'Bob', department: 'Marketing', salary: 75000 },
  { id: 3, name: 'Charlie', department: 'Sales', salary: 85000 },
]);

const columns: ColumnConfig<Employee>[] = [
  { field: 'id', header: 'ID', type: 'number', width: 70 },
  { field: 'name', header: 'Name', editable: true, sortable: true },
  { field: 'department', header: 'Department', editable: true, sortable: true },
  { field: 'salary', header: 'Salary', type: 'number', format: (v: number) => '$' + v.toLocaleString() },
];
</script>

<template>
  <TbwGrid
    :rows="employees"
    :columns="columns"
    selection="range"
    editing="dblclick"
    :multi-sort="true"
    :filtering="{ debounceMs: 200 }"
    style="height: 400px; display: block"
  />
</template>
```

## Feature Prop Reference

Each feature prop enables a specific plugin with simplified configuration:

| Feature Prop | Feature Import | Description |
|--------------|----------------|-------------|
| `selection` | `features/selection` | Cell, row, or range selection |
| `editing` | `features/editing` | Inline cell editing |
| `multi-sort` | `features/multi-sort` | Multi-column sorting |
| `filtering` | `features/filtering` | Column filtering |
| `clipboard` | `features/clipboard` | Copy/paste support |
| `context-menu` | `features/context-menu` | Right-click context menu |
| `reorder-columns` | `features/reorder-columns` | Column drag-to-reorder |
| `visibility` | `features/visibility` | Column visibility panel |
| `pinned-columns` | `features/pinned-columns` | Sticky left/right columns |
| `pinned-rows` | `features/pinned-rows` | Sticky top/bottom rows |
| `grouping-columns` | `features/grouping-columns` | Multi-level column headers |
| `grouping-rows` | `features/grouping-rows` | Row grouping |
| `column-virtualization` | `features/column-virtualization` | Virtualize columns for wide grids |
| `reorder-rows` | `features/reorder-rows` | Row drag-to-reorder |
| `tree` | `features/tree` | Hierarchical tree view |
| `master-detail` | `features/master-detail` | Expandable detail rows |
| `responsive` | `features/responsive` | Card layout for narrow viewports |
| `undo-redo` | `features/undo-redo` | Edit undo/redo |
| `export` | `features/export` | CSV/Excel export |
| `print` | `features/print` | Print support |
| `pivot` | `features/pivot` | Pivot table functionality |
| `server-side` | `features/server-side` | Server-side data loading |
| `sticky-rows` | `features/sticky-rows` | Pin selected data rows below the header on scroll |
| `row-drag-drop` | `features/row-drag-drop` | Row drag-and-drop (within and across grids) |
| `tooltip` | `features/tooltip` | Cell / header tooltips |

**Core Config Props (no feature import needed):**

| Prop | Type | Description |
|------|------|-------------|
| `sortable` | `boolean` | Grid-wide sorting toggle (default: true) |
| `filterable` | `boolean` | Grid-wide filtering toggle (default: true). Requires FilteringPlugin. |
| `selectable` | `boolean` | Grid-wide selection toggle (default: true). Requires SelectionPlugin. |

## Header & Toolbar Content

Inject Vue components into the grid's shell header (left zone) or toolbar (right zone) via `<TbwGridHeaderContent>` and `<TbwGridToolbarContent>`. These wrap the imperative `registerHeaderContent` / `registerToolbarContent` APIs using Vue's built-in `<Teleport>`, so slot content keeps full reactivity (props, refs, computed, slots, provide/inject).

```html
<script setup lang="ts">
import { TbwGrid, TbwGridHeaderContent, TbwGridToolbarContent } from '@toolbox-web/grid-vue';
import { ref } from 'vue';
const year = ref(new Date().getFullYear());
</script>

<template>
  <TbwGrid :rows="rows" :grid-config="config">
    <TbwGridHeaderContent id="calendar-nav" :order="0">
      <HeaderNav :year="year" @year-change="year = $event" />
    </TbwGridHeaderContent>
    <TbwGridToolbarContent id="calendar-buttons" :order="0">
      <ToolbarNav @prev="prev" @today="today" @next="next" />
    </TbwGridToolbarContent>
  </TbwGrid>
</template>
```

**Props:** `id` (optional — auto-generated if omitted), `order` (default `100`, lower = first). Slot content updates reactively without re-registering with the grid.

## Programmatic Grid Access

Use the `useGrid` composable for programmatic control:

```html
<script setup lang="ts">
import { TbwGrid, useGrid } from '@toolbox-web/grid-vue';
import { ref } from 'vue';

interface Employee {
  id: number;
  name: string;
}

const employees = ref<Employee[]>([/* ... */]);
const { gridElement, forceLayout } = useGrid();

function refreshGrid() {
  forceLayout();
}

async function exportCsv() {
  const grid = gridElement.value;
  if (!grid) return;

  const exportPlugin = grid.getPluginByName('export');
  await exportPlugin?.exportToCsv({ filename: 'employees.csv' });
}
</script>

<template>
  <div>
    <button @click="refreshGrid">Refresh</button>
    <button @click="exportCsv">Export CSV</button>
    <TbwGrid :rows="employees" :columns="columns" />
  </div>
</template>
```

## Feature-Scoped Composables

Feature imports export **scoped composables** for type-safe programmatic access to plugin functionality:

```html
<script setup lang="ts">
import '@toolbox-web/grid-vue/features/export';
import { useGridExport } from '@toolbox-web/grid-vue/features/export';
import { TbwGrid } from '@toolbox-web/grid-vue';
import { ref } from 'vue';

const employees = ref<Employee[]>([/* ... */]);
const { exportToCsv, exportToExcel, isExporting } = useGridExport();
</script>

<template>
  <div>
    <button @click="exportToCsv('employees.csv')" :disabled="isExporting()">Export CSV</button>
    <TbwGrid :rows="employees" :columns="columns" export />
  </div>
</template>
```

### Available Feature Composables

See the **API Reference > Composables** section for detailed method signatures, return types, and examples.

All composables accept an optional `selector` parameter to target a specific grid via DOM query instead of Vue's provide/inject. Use when a component contains multiple grids:

```html
<script setup>
import { useGridSelection } from '@toolbox-web/grid-vue/features/selection';

// Target a specific grid by CSS selector
const selection = useGridSelection('tbw-grid.primary');
</script>
```

| Composable | Import | Key Methods |
|------------|--------|-------------|
| `useGridSelection()` | `features/selection` | `selectAll`, `clearSelection`, `getSelection`, `getSelectedRows` |
| `useGridFiltering()` | `features/filtering` | `setFilter`, `clearAllFilters`, `getFilters`, `getFilteredRowCount` |
| `useGridExport()` | `features/export` | `exportToCsv`, `exportToExcel`, `exportToJson`, `isExporting` |
| `useGridPrint()` | `features/print` | `print`, `isPrinting` |
| `useGridUndoRedo()` | `features/undo-redo` | `undo`, `redo`, `canUndo`, `canRedo` |

## Overlay Editors (`useGridOverlay`)

Custom Vue editors that open a popover, listbox, calendar, or other floating panel typically render that panel through `<Teleport>` so it can escape the cell's overflow clipping. Without help, the grid sees a click into the teleported panel as a click _outside_ the editor and commits-and-exits the row before the user can pick an option.

The `useGridOverlay` composable bridges that gap by registering the panel with the grid as an external focus container — the Vue equivalent of Angular's `BaseOverlayEditor.initOverlay()` and React's `useGridOverlay`. Pair it with `aria-expanded` / `aria-controls` on the trigger so even editors that forget to call the composable get correct keyboard / pointer behaviour out of the box (the editing plugin honours those attributes as a generic fallback — see [issue #251](https://github.com/datafabric/toolbox-web/issues/251)).

```html
<script setup lang="ts">
import { ref, useId } from 'vue';
import { useGridOverlay, type GridEditorContext } from '@toolbox-web/grid-vue';

const props = defineProps<{ ctx: GridEditorContext<MyRow> }>();
const open = ref(false);
const panel = ref<HTMLElement | null>(null);
const listboxId = useId();

// Registers panel.value with the grid while open.value === true; unregisters
// automatically on close or unmount.
useGridOverlay(panel, { open });
</script>

<template>
  <input
    role="combobox"
    :aria-expanded="open"
    :aria-controls="listboxId"
    :value="ctx.value ?? ''"
    @click="open = true"
    @keydown.escape="ctx.cancel()"
  />
  <Teleport to="body" v-if="open">
    <div ref="panel" :id="listboxId" role="listbox" class="my-listbox">
      <!-- options that call ctx.commit(option) on click -->
    </div>
  </Teleport>
</template>
```

`useGridOverlay(panelRef, options?)` resolves the owning `<tbw-grid>` in this order:

1. `options.gridElement` if explicitly passed (accepts a `MaybeRef<DataGridElement>`),
2. `panelRef.value.closest('tbw-grid')` for inline (non-teleported) panels,
3. The `GRID_ELEMENT_KEY` injection populated by `<TbwGrid>` / `<GridProvider>`.

`options.open` accepts a `MaybeRef<boolean>` so reactive refs and plain booleans both work. The grid host is also exposed on `ColumnEditorContext.grid` for editors that need to call grid APIs directly without using the composable.

## Manual Plugin Instantiation

For custom configurations or third-party plugins, instantiate manually using `markRaw()`:

```html
<script setup lang="ts">
import { TbwGrid, type GridConfig } from '@toolbox-web/grid-vue';
import { SelectionPlugin, EditingPlugin, ClipboardPlugin } from '@toolbox-web/grid/all';
import { markRaw, ref } from 'vue';

const employees = ref<Employee[]>([/* ... */]);

const config = markRaw<GridConfig<Employee>>({
  columns: [
    { field: 'id', header: 'ID' },
    { field: 'name', header: 'Name', editable: true },
  ],
  plugins: [
    new SelectionPlugin({ mode: 'range', checkbox: true }),
    new EditingPlugin({ editOn: 'dblclick' }),
    new ClipboardPlugin({ includeHeaders: true }),
  ],
});
</script>

<template>
  <TbwGrid :rows="employees" :grid-config="config" />
</template>
```

> **Important**: Always use `markRaw()` for grid configs containing plugins. Vue's reactivity system can interfere with plugin class instances.

Feature props and manual plugins can be mixed — the grid merges them.

## Custom Icons

The grid supports two complementary ways to customize icons — see the [Theming Guide → Icon Customization](/grid/guides/theming.md#icon-customization) for both the CSS and JavaScript approaches:

- **CSS variables** (`--tbw-icon-*`) — preferred for themes and static customization; no JavaScript needed.
- **`gridConfig.icons`** — for dynamic icons, icon libraries, or `HTMLElement` instances; takes precedence over CSS.

`GridIconProvider` is the Vue wrapper for the JS path — it injects `icons` into `gridConfig.icons` for every descendant `<TbwGrid>`:

```html
<script setup lang="ts">
import { GridIconProvider, TbwGrid } from '@toolbox-web/grid-vue';
</script>

<template>
  <GridIconProvider :icons="{ sortAsc: '↑', sortDesc: '↓' }">
    <TbwGrid :rows="employees" :columns="columns" />
  </GridIconProvider>
</template>
```

## Server-Side Data Loading

For backends that own paging / sorting / filtering, use the `serverSide` feature prop. Your `getRows` handler receives the current `sortModel`, `filterModel`, and block range — return rows and the total count. See [`ServerSideDataSource`](/grid/plugins/server-side/interfaces/serversidedatasource.md), [`GetRowsParams`](/grid/plugins/server-side/interfaces/getrowsparams.md), and [`GetRowsResult`](/grid/plugins/server-side/interfaces/getrowsresult.md) for the full contract — including the `params.signal` `AbortSignal` you can forward to `fetch()` for explicit cancellation.

```html
<script setup lang="ts">
import '@toolbox-web/grid-vue/features/server-side';
import '@toolbox-web/grid-vue/features/multi-sort';
import { TbwGrid } from '@toolbox-web/grid-vue';
import type { ServerSideDataSource } from '@toolbox-web/grid/plugins/server-side';

const dataSource: ServerSideDataSource<Employee> = {
  getRows: async ({ startNode, endNode, sortModel, filterModel, signal }) => {
    const params = new URLSearchParams({
      from: String(startNode),
      to: String(endNode),
    });
    if (sortModel?.length) {
      params.set(
        'sort',
        sortModel.map((s) => `${s.field}:${s.direction}`).join(','),
      );
    }
    if (filterModel) params.set('filter', JSON.stringify(filterModel));
    const response = await fetch(`/api/employees?${params}`, { signal });
    const { rows, totalNodeCount } = await response.json();
    return { rows, totalNodeCount };
  },
};
</script>

<template>
  <TbwGrid
    :columns="columns"
    multi-sort
    :server-side="{ dataSource, pageSize: 100 }"
  />
</template>
```

:::tip
Avoid `gridConfig.sortHandler` for server-side sort — it's bypassed when the multi-sort feature is loaded and only carries a single field. The `serverSide` feature is the supported path and works with both single- and multi-column sort.
:::

### VueQuery (TanStack Query) Integration

If your app already uses [TanStack Vue Query](https://tanstack.com/query/latest/docs/framework/vue/overview),
one useful pairing is to back `ServerSidePlugin` with Vue Query's request cache.
Each block the grid asks for becomes a query keyed by the request shape
(`startNode`, `endNode`, `sortModel`, `filterModel`) — so scrolling back to a
previously fetched range is served from cache instead of re-hitting the API,
and you get retries, in-flight deduplication, and devtools for free.

The pattern: keep `getRows` thin and delegate fetching to `queryClient.fetchQuery`
with a stable key per block.

```html
<script setup lang="ts">
import '@toolbox-web/grid-vue/features/server-side';
import '@toolbox-web/grid-vue/features/multi-sort';
import { TbwGrid } from '@toolbox-web/grid-vue';
import type {
  GetRowsParams,
  GetRowsResult,
  ServerSideDataSource,
} from '@toolbox-web/grid/plugins/server-side';
import { useQueryClient } from '@tanstack/vue-query';

async function fetchEmployeeBlock(
  params: GetRowsParams,
): Promise<GetRowsResult<Employee>> {
  const search = new URLSearchParams({
    from: String(params.startNode),
    to: String(params.endNode),
  });
  if (params.sortModel?.length) {
    search.set('sort', params.sortModel.map((s) => `${s.field}:${s.direction}`).join(','));
  }
  if (params.filterModel) search.set('filter', JSON.stringify(params.filterModel));
  const response = await fetch(`/api/employees?${search}`, { signal: params.signal });
  return response.json();
}

const queryClient = useQueryClient();

const dataSource: ServerSideDataSource<Employee> = {
  // Each block becomes a cached query — Vue Query dedupes in-flight
  // requests, retries failed ones, and serves repeated scrolls from cache.
  getRows: (params) =>
    queryClient.fetchQuery({
      queryKey: [
        'employees',
        params.startNode,
        params.endNode,
        params.sortModel,
        params.filterModel,
      ],
      queryFn: ({ signal }) => fetchEmployeeBlock({ ...params, signal }),
      staleTime: 60_000,
    }),
};
</script>

<template>
  <TbwGrid
    :columns="columns"
    multi-sort
    :server-side="{ dataSource, pageSize: 100 }"
  />
</template>
```

:::tip
When the user mutates a row (commit, paste, etc.), invalidate the query to
trigger a refresh: `queryClient.invalidateQueries({ queryKey: ['employees'] })`.
The grid will re-request the affected blocks on next scroll.
:::

## Dynamic Row Updates

```html
<script setup lang="ts">
import { TbwGrid } from '@toolbox-web/grid-vue';
import { ref } from 'vue';

const employees = ref<Employee[]>([
  { id: 1, name: 'Alice', department: 'Engineering' },
  { id: 2, name: 'Bob', department: 'Design' },
]);

let nextId = 3;

function handleAdd() {
  employees.value = [
    ...employees.value,
    { id: nextId++, name: 'New Employee', department: 'TBD' },
  ];
}

function removeFirst() {
  employees.value = employees.value.slice(1);
}
</script>

<template>
  <div>
    <button @click="handleAdd">Add</button>
    <button @click="removeFirst">Remove First</button>
    <TbwGrid :rows="employees" :columns="columns" />
  </div>
</template>
```

## Performance Tips

### Use `markRaw` for Config Objects

```typescript
import { markRaw } from 'vue';

// ✅ Prevents Vue from making config deeply reactive
const config = markRaw({ columns: [...], features: { selection: true } });
```

### Use `shallowRef` for Large Datasets

```typescript
import { shallowRef } from 'vue';

// ✅ Only tracks reference changes, not deep mutations
const employees = shallowRef<Employee[]>([]);
employees.value = [...employees.value, newEmployee];
```

### Memoize Column Configurations

```typescript
import { computed, markRaw } from 'vue';

// ✅ Only recreated when dependencies change
const columns = computed(() => markRaw([
  { field: 'id', header: 'ID' },
  { field: 'name', header: 'Name' },
]));
```

## Troubleshooting

### Feature prop not working

Ensure you imported the feature side-effect in your `main.ts`:

```typescript
import '@toolbox-web/grid-vue/features/selection';
```

### `tbw-grid` not recognized as a component

Add the `isCustomElement` config to your Vite setup:

```typescript
// vite.config.ts
vue({
  template: {
    compilerOptions: {
      isCustomElement: (tag) => tag.startsWith('tbw-'),
    },
  },
})
```

### Row updates not reflected

The grid detects updates via reference equality. Always assign a new array:

```typescript
// ✅ New reference — grid re-renders
employees.value = [...employees.value, newRow];

// ❌ Same reference — grid won't detect change
employees.value.push(newRow);
```

## See Also

- **API Reference** — Browse all components, composables, and types via the Vue API section in the sidebar
- **[Grid Plugins](/grid/plugins.md)** — All available plugins
- **[Core Features](/grid/core.md)** — Variable row heights, events, column config
- **[Common Patterns](/grid/guides/common-patterns.md)** — Reusable recipes


# React Integration

> Install and configure @toolbox-web/grid-react — feature props, JSX renderers, editors, hooks, and event handling.

The `@toolbox-web/grid-react` package provides React integration for the `<tbw-grid>` data grid component.

:::note[Where to find feature docs]
This page covers React-specific setup and APIs (feature props, hooks, providers). Core grid features and plugins — cell renderers, editors, events, master-detail, sorting, filtering, selection, etc. — are documented on the [Core](/grid/core.md) and [Plugins](/grid/plugins.md) pages, each with a React tab and runnable demos.
:::

## Compatibility

| React version | Support level |
| ------------- | ------------- |
| 19            | **Tested** — used in demos and CI |
| 18            | **Tested** |
| &lt; 18       | Not supported (minimum peer dependency) |

## Installation

#### npm

  ```bash
  npm install @toolbox-web/grid @toolbox-web/grid-react
  ```

#### yarn

  ```bash
  yarn add @toolbox-web/grid @toolbox-web/grid-react
  ```

#### pnpm

  ```bash
  pnpm add @toolbox-web/grid @toolbox-web/grid-react
  ```

#### bun

  ```bash
  bun add @toolbox-web/grid @toolbox-web/grid-react
  ```

## Setup

Register the grid web component in your application entry point:

```typescript
// main.tsx or index.tsx
import '@toolbox-web/grid';
```

## Basic Usage

The simplest way to use the grid is with the `DataGrid` component:

```tsx
import { useState } from 'react';
import { DataGrid } from '@toolbox-web/grid-react';

interface Employee {
  id: number;
  name: string;
  department: string;
  salary: number;
}

function EmployeeGrid() {
  const [employees] = useState<Employee[]>([
    { id: 1, name: 'Alice', department: 'Engineering', salary: 95000 },
    { id: 2, name: 'Bob', department: 'Marketing', salary: 75000 },
    { id: 3, name: 'Charlie', department: 'Sales', salary: 85000 },
  ]);

  return (
    <DataGrid
      rows={employees}
      columns={[
        { field: 'id', header: 'ID', width: 70 },
        { field: 'name', header: 'Name', sortable: true },
        { field: 'department', header: 'Department', sortable: true },
        { field: 'salary', header: 'Salary', type: 'number' },
      ]}
      style={{ height: 400, display: 'block' }}
    />
  );
}
```

## Enabling Features with Props

Features are enabled using **declarative props** combined with **side-effect imports**. This gives you clean JSX and tree-shakeable bundles.

### How It Works

1. **Import the feature** - A side-effect import registers the feature factory
2. **Use the prop** - DataGrid detects the prop and creates the plugin instance

```tsx
// 1. Import features you need (once per feature)
import '@toolbox-web/grid-react/features/selection';
import '@toolbox-web/grid-react/features/multi-sort';
import '@toolbox-web/grid-react/features/editing';
import '@toolbox-web/grid-react/features/filtering';

import { DataGrid } from '@toolbox-web/grid-react';

function EmployeeGrid() {
  return (
    <DataGrid
      rows={employees}
      columns={columns}
      // 2. Just use the props - plugins are created automatically!
      selection="range"           // SelectionPlugin with mode: 'range'
      multiSort                   // MultiSortPlugin
      editing="dblclick"          // EditingPlugin with editOn: 'dblclick'
      filtering                   // FilteringPlugin with defaults
    />
  );
}
```

### Why Side-Effect Imports?

- **Tree-shakeable** - Only the features you import are bundled
- **Synchronous** - No loading states, no HTTP requests, no spinners
- **Type-safe** - Full TypeScript support for feature props
- **Clean JSX** - No `plugins: [new SelectionPlugin({ mode: 'range' })]` boilerplate

### Available Features

| Import | Prop | Example |
|--------|------|---------|
| `features/selection` | `selection` | `selection="range"` or `selection={{ mode: 'row', checkbox: true }}` |
| `features/multi-sort` | `multiSort` | `multiSort` or `multiSort={{ maxSortColumns: 3 }}` |
| `features/filtering` | `filtering` | `filtering` or `filtering={{ debounceMs: 200 }}` |
| `features/editing` | `editing` | `editing="dblclick"` or `editing="click"` |
| `features/clipboard` | `clipboard` | `clipboard` (requires selection) |
| `features/undo-redo` | `undoRedo` | `undoRedo` (requires editing) |
| `features/context-menu` | `contextMenu` | `contextMenu` |
| `features/reorder-columns` | `reorderColumns` | `reorderColumns` (column drag-to-reorder) |
| `features/visibility` | `visibility` | `visibility` (column visibility panel) |
| `features/pinned-columns` | `pinnedColumns` | `pinnedColumns` |
| `features/grouping-columns` | `groupingColumns` | `groupingColumns` |
| `features/grouping-rows` | `groupingRows` | `groupingRows={{ groupOn: (row) => row.department }}` |
| `features/tree` | `tree` | `tree={{ childrenField: 'children' }}` |
| `features/master-detail` | `masterDetail` | `masterDetail` (use with `<GridDetailPanel>`) |
| `features/responsive` | `responsive` | `responsive` (card layout on mobile) |
| `features/export` | `export` | `export` |
| `features/print` | `print` | `print` |
| `features/pinned-rows` | `pinnedRows` | `pinnedRows` or `pinnedRows={{ position: 'bottom' }}` |
| `features/column-virtualization` | `columnVirtualization` | `columnVirtualization` |
| `features/reorder-rows` | `reorderRows` | `reorderRows` |
| `features/pivot` | `pivot` | `pivot={{ rowFields: ['category'], valueField: 'sales' }}` |
| `features/server-side` | `serverSide` | `serverSide={{ pageSize: 50 }}` |
| `features/sticky-rows` | `stickyRows` | `stickyRows={{ isSticky: 'isSection' }}` |
| `features/row-drag-drop` | `rowDragDrop` | `rowDragDrop` (cross-grid / external row drag-and-drop) |
| `features/tooltip` | `tooltip` | `tooltip` (cell / header tooltips) |

### Core Config Props (no import needed)

These props control core grid behaviour and don't require feature imports. See [`DataGridProps`](/grid/react/api/types/datagridprops.md) for the full prop surface and [`AllFeatureProps`](/grid/react/api/types/allfeatureprops.md) for every typed feature prop.

| Prop | Type | Default | Description |
|------|------|---------|-------------|
| `rows` | `T[]` | `[]` | Row data — omit when using `serverSide` |
| `columns` | [`ColumnConfig`](/grid/api/core/interfaces/columnconfig.md)`[]` | — | Column definitions (alternative to `gridConfig.columns`) |
| `gridConfig` | [`GridConfig`](/grid/api/core/interfaces/gridconfig.md) | — | Full configuration object — always wrap in `useMemo` |
| `ref` | [`Ref<DataGridRef>`](/grid/react/api/types/datagridref.md) | — | Imperative handle (also returned by `useGrid()`) |
| `loading` | `boolean` | `false` | Show the grid's loading overlay |
| `fitMode` | `FitMode` | `'auto'` | Column-fit strategy |
| `customStyles` | `string` | — | CSS injected into the grid (renderer/editor styling) |
| `ssr` | `boolean` | `false` | **Deprecated** — no-op in practice; will be removed in a future major release |
| `sortable` | `boolean` | `true` | Grid-wide sorting toggle. Set `false` to disable all sorting. |
| `filterable` | `boolean` | `true` | Grid-wide filtering toggle. Requires FilteringPlugin. |
| `selectable` | `boolean` | `true` | Grid-wide selection toggle. Requires SelectionPlugin. |

```tsx
// Disable sorting and selection at runtime
<DataGrid
  sortable={false}
  selectable={false}
  selection="range"  // Plugin loaded but disabled via selectable={false}
/>
```

### Import All Features (Development)

For prototyping or when bundle size isn't critical:

```tsx
// Import all features at once
import '@toolbox-web/grid-react/features';

// Now all feature props work
<DataGrid selection="range" multiSort filtering editing="dblclick" clipboard />
```

## Custom Tool Panels

Use [`GridToolPanel`](/grid/react/api/components/gridtoolpanel.md) to declare a sidebar panel inline. The component renders a `<tbw-grid-tool-panel>` element in the grid's light DOM — the shell picks it up automatically, so **no `gridConfig.shell.toolPanels` registration is needed**. The `children` prop is a render function that receives a [`ToolPanelContext`](/grid/react/api/types/toolpanelcontext.md) (`{ grid }`).

```tsx
import { DataGrid, GridToolPanel, type ToolPanelContext } from '@toolbox-web/grid-react';

function EmployeeGrid() {
  return (
    <DataGrid rows={employees} columns={columns}>
      <GridToolPanel
        id="filters"
        title="Quick Filters"
        icon="🔍"
        order={10}
      >
        {({ grid }: ToolPanelContext) => (
          <div style={{ padding: 16 }}>
            <h3>Quick Filters</h3>
            <label>
              <input type="checkbox" /> Active Only
            </label>
          </div>
        )}
      </GridToolPanel>
    </DataGrid>
  );
}
```

**Props:** `id` (required), `title` (required), `icon`, `tooltip`, `order` (default `100`, lower = first).

## Header & Toolbar Content

Inject framework content into the grid's shell header (left zone) or toolbar (right zone) via [`GridHeaderContent`](/grid/react/api/components/gridheadercontent.md) and [`GridToolbarContent`](/grid/react/api/components/gridtoolbarcontent.md). These wrap the imperative `registerHeaderContent` / `registerToolbarContent` APIs so children render through React's normal reconciliation (state, context, hooks all work).

```tsx
import { DataGrid, GridHeaderContent, GridToolbarContent } from '@toolbox-web/grid-react';

function CalendarGrid() {
  const [year, setYear] = useState(new Date().getFullYear());
  return (
    <DataGrid rows={rows} columns={columns}>
      <GridHeaderContent id="calendar-nav" order={0}>
        <HeaderNav year={year} onYearChange={setYear} />
      </GridHeaderContent>
      <GridToolbarContent id="calendar-buttons" order={0}>
        <ToolbarNav onPrev={prev} onToday={today} onNext={next} />
      </GridToolbarContent>
    </DataGrid>
  );
}
```

**Props:** `id` (optional — auto-generated if omitted), `order` (default `100`, lower = first). Children re-render in place when state changes without re-registering with the grid.

## Using the `useGrid` Hook

The [`useGrid()`](/grid/react/api/hooks/usegrid.md) hook provides programmatic access to the grid — see [`UseGridReturn`](/grid/react/api/types/usegridreturn.md) for the full return shape. It exposes core grid operations only; **feature-specific operations (export, selection, filtering, etc.) live on the dedicated feature hooks** (`useGridSelection`, `useGridExport`, ...) listed below.

```tsx
import { DataGrid, useGrid } from '@toolbox-web/grid-react';

function EmployeeGrid() {
  const {
    ref,                  // Pass to DataGrid
    element,              // Direct grid element access
    isReady,              // True once the grid has booted
    config,               // Current effective GridConfig (snapshot)
    getConfig,            // async: re-read effective config
    forceLayout,          // async: force a layout pass
    toggleGroup,          // async: toggle a group row by key
    getPlugin,            // Get plugin instance by class
    getPluginByName,      // Get plugin instance by registered name
    registerStyles,       // Inject scoped CSS
    unregisterStyles,
    getVisibleColumns,    // Filtered list of non-hidden columns
  } = useGrid<Employee>();

  return (
    <div>
      <button onClick={() => forceLayout()}>Force Layout</button>
      <button disabled={!isReady} onClick={async () => console.log(await getConfig())}>
        Log Config
      </button>
      <DataGrid ref={ref} rows={employees} columns={columns} />
    </div>
  );
}
```

For selection, export, filtering, undo-redo, or print operations, use the feature hooks — they handle the per-plugin wiring:

```tsx
import '@toolbox-web/grid-react/features/selection';
import '@toolbox-web/grid-react/features/export';
import { useGridSelection } from '@toolbox-web/grid-react/features/selection';
import { useGridExport } from '@toolbox-web/grid-react/features/export';

function Toolbar() {
  const { selectAll, clearSelection, getSelectedRows } = useGridSelection<Employee>();
  const { exportToCsv, isExporting } = useGridExport();

  return (
    <div className="toolbar">
      <button onClick={() => exportToCsv('employees.csv')} disabled={isExporting()}>
        Export CSV
      </button>
      <button onClick={selectAll}>Select All</button>
      <button onClick={() => console.log(getSelectedRows())}>Log Selection</button>
      <button onClick={clearSelection}>Clear</button>
    </div>
  );
}
```

### Multiple Grids

When a component contains multiple grids, pass a CSS selector to target a specific one:

```tsx
import { useGrid } from '@toolbox-web/grid-react';
import { useGridSelection } from '@toolbox-web/grid-react/features/selection';

function MultiGridPage() {
  // Target grids by selector instead of ref/context
  const primaryGrid = useGrid('#primary-grid');
  const selection = useGridSelection('#primary-grid');

  return (
    <div>
      <DataGrid id="primary-grid" rows={employees} selection="row" />
      <DataGrid id="secondary-grid" rows={departments} />
    </div>
  );
}
```

## Type-Level Defaults

Register application-wide renderers for data types using `GridTypeProvider` (see [`GridTypeProviderProps`](/grid/react/api/types/gridtypeproviderprops.md)) with a [`TypeDefaultsMap`](/grid/react/api/types/typedefaultsmap.md):

```tsx
import { GridTypeProvider, DataGrid, type TypeDefaultsMap } from '@toolbox-web/grid-react';

// Define type defaults for your application
const typeDefaults: TypeDefaultsMap = {
  currency: {
    format: (value: number) => '$' + value.toLocaleString(),
    renderer: ({ value }) => (
      <span style={{ color: value < 0 ? 'red' : 'green' }}>{value}</span>
    ),
  },
  date: {
    format: (value: string) => new Date(value).toLocaleDateString(),
  },
  boolean: {
    renderer: ({ value }) => <span>{value ? '✅' : '❌'}</span>,
  },
};

// Wrap your app (or a section) with the provider
function App() {
  return (
    <GridTypeProvider defaults={typeDefaults}>
      <EmployeeGrid />
    </GridTypeProvider>
  );
}

// Now columns with these types use the defaults automatically
function EmployeeGrid() {
  return (
    <DataGrid
      rows={employees}
      columns={[
        { field: 'salary', header: 'Salary', type: 'currency' },    // Uses currency format/renderer
        { field: 'hireDate', header: 'Hire Date', type: 'date' },   // Uses date format
        { field: 'isActive', header: 'Active', type: 'boolean' },   // Uses boolean renderer
      ]}
    />
  );
}
```

## Feature-Scoped Hooks

Feature imports export **scoped hooks** for type-safe programmatic access to plugin functionality:

```tsx
import '@toolbox-web/grid-react/features/export';
import { useGridExport } from '@toolbox-web/grid-react/features/export';
import { DataGrid } from '@toolbox-web/grid-react';

function EmployeeGrid() {
  const { exportToCsv, exportToExcel, isExporting } = useGridExport();

  return (
    <div>
      <button onClick={() => exportToCsv('employees.csv')} disabled={isExporting()}>
        Export CSV
      </button>
      <DataGrid rows={employees} columns={columns} export />
    </div>
  );
}
```

### Available Feature Hooks

See the **API Reference > Hooks** section for detailed method signatures, return types, and examples.

| Hook | Import | Key Methods |
|------|--------|-------------|
| [`useGridSelection()`](/grid/react/api/features/usegridselection.md) | `features/selection` | `selectAll`, `clearSelection`, `getSelection`, `getSelectedRows` |
| [`useGridFiltering()`](/grid/react/api/features/usegridfiltering.md) | `features/filtering` | `setFilter`, `clearAllFilters`, `getFilters`, `getFilteredRowCount` |
| [`useGridExport()`](/grid/react/api/features/usegridexport.md) | `features/export` | `exportToCsv`, `exportToExcel`, `exportToJson`, `isExporting` |
| [`useGridPrint()`](/grid/react/api/features/usegridprint.md) | `features/print` | `print`, `isPrinting` |
| [`useGridUndoRedo()`](/grid/react/api/features/usegridundoredo.md) | `features/undo-redo` | `undo`, `redo`, `canUndo`, `canRedo` |

## Overlay Editors (`useGridOverlay`)

Custom React editors that open a popover, listbox, calendar, or other floating panel typically render that panel into a portal so it can escape the cell's overflow clipping. Without help, the grid sees a click into the portal as a click _outside_ the editor and commits-and-exits the row before the user can pick an option.

The `useGridOverlay` hook bridges that gap by registering the panel with the grid as an external focus container — the React equivalent of Angular's `BaseOverlayEditor.initOverlay()`. Pair it with `aria-expanded` / `aria-controls` on the trigger so even editors that forget to call the hook get correct keyboard / pointer behaviour out of the box (the editing plugin honours those attributes as a generic fallback — see [issue #251](https://github.com/datafabric/toolbox-web/issues/251)).

```tsx
import { createPortal } from 'react-dom';
import { useId, useRef, useState } from 'react';
import { useGridOverlay, type GridEditorContext } from '@toolbox-web/grid-react';

function AutocompleteEditor({ value, commit, cancel }: GridEditorContext<MyRow>) {
  const [open, setOpen] = useState(false);
  const panelRef = useRef<HTMLDivElement | null>(null);
  const listboxId = useId();

  // Registers panelRef.current with the grid while open=true; unregisters
  // automatically on close or unmount.
  useGridOverlay(panelRef, { open });

  return (
    <>
      <input
        role="combobox"
        aria-expanded={open}
        aria-controls={listboxId}
        defaultValue={String(value ?? '')}
        onClick={() => setOpen(true)}
        onKeyDown={(e) => {
          if (e.key === 'Escape') cancel();
        }}
      />
      {open &&
        createPortal(
          <div ref={panelRef} id={listboxId} role="listbox" className="my-listbox">
            {/* options that call commit(option) on click */}
          </div>,
          document.body,
        )}
    </>
  );
}
```

`useGridOverlay(panelRef, options?)` resolves the owning `<tbw-grid>` in this order:

1. `options.gridElement` if explicitly passed,
2. `panelRef.current.closest('tbw-grid')` for inline (non-portaled) panels,
3. The `GridElementContext` populated by `<DataGrid>` / `<GridProvider>`.

The grid host is also exposed on `ColumnEditorContext.grid` for editors that need to call grid APIs directly without using the hook.

## Manual Plugin Instantiation

Feature props are the recommended path. Use manual plugin instantiation only when you need a third-party plugin or a configuration the feature prop doesn't expose. Feature props and manual plugins can be mixed — the grid merges them.

```tsx
import { useMemo } from 'react';
import { DataGrid, type GridConfig } from '@toolbox-web/grid-react';
import { SelectionPlugin } from '@toolbox-web/grid/plugins/selection';
import { MyCustomPlugin } from './my-custom-plugin';

function EmployeeGrid() {
  const config = useMemo<GridConfig<Employee>>(() => ({
    columns: [
      { field: 'id', header: 'ID' },
      { field: 'name', header: 'Name', editable: true },
    ],
    plugins: [
      new SelectionPlugin({ mode: 'range', checkbox: true }),
      new MyCustomPlugin({ /* third-party config */ }),
    ],
  }), []);

  return <DataGrid rows={employees} gridConfig={config} />;
}
```

> **Important**: Always use `useMemo` for config objects to prevent re-creating them on every render.

## Custom Icons

The grid supports two complementary ways to customize icons — see the [Theming Guide → Icon Customization](/grid/guides/theming.md#icon-customization) for both the CSS and JavaScript approaches:

- **CSS variables** (`--tbw-icon-*`) — preferred for themes and static customization; no JavaScript needed.
- **`gridConfig.icons`** — for dynamic icons, icon libraries, or `HTMLElement` instances; takes precedence over CSS.

`GridIconProvider` is the React wrapper for the JS path — it injects `icons` into `gridConfig.icons` for every descendant `<DataGrid>`:

```tsx
import { GridIconProvider, DataGrid } from '@toolbox-web/grid-react';

function App() {
  return (
    <GridIconProvider icons={{ sortAsc: '↑', sortDesc: '↓' }}>
      <DataGrid rows={employees} columns={columns} />
    </GridIconProvider>
  );
}
```

## Server-Side Data Loading

For backends that own paging / sorting / filtering, use the `serverSide` feature prop. Your `getRows` handler receives the current `sortModel`, `filterModel`, and block range — return rows and the total count. See [`ServerSideDataSource`](/grid/plugins/server-side/interfaces/serversidedatasource.md), [`GetRowsParams`](/grid/plugins/server-side/interfaces/getrowsparams.md), and [`GetRowsResult`](/grid/plugins/server-side/interfaces/getrowsresult.md) for the full contract — including the `params.signal` `AbortSignal` you can forward to `fetch()` for explicit cancellation.

```tsx
import '@toolbox-web/grid-react/features/server-side';
import '@toolbox-web/grid-react/features/multi-sort';
import { useMemo } from 'react';
import { DataGrid } from '@toolbox-web/grid-react';
import type { ServerSideDataSource } from '@toolbox-web/grid/plugins/server-side';

function ServerSideGrid() {
  const dataSource = useMemo<ServerSideDataSource<Employee>>(() => ({
    getRows: async ({ startNode, endNode, sortModel, filterModel, signal }) => {
      const params = new URLSearchParams({
        from: String(startNode),
        to: String(endNode),
      });
      if (sortModel?.length) {
        params.set(
          'sort',
          sortModel.map((s) => `${s.field}:${s.direction}`).join(','),
        );
      }
      if (filterModel) params.set('filter', JSON.stringify(filterModel));
      const response = await fetch(`/api/employees?${params}`, { signal });
      const { rows, totalNodeCount } = await response.json();
      return { rows, totalNodeCount };
    },
  }), []);

  return (
    <DataGrid
      columns={columns}
      multiSort
      serverSide={{ dataSource, pageSize: 100 }}
    />
  );
}
```

:::tip
Avoid `gridConfig.sortHandler` for server-side sort — it's bypassed when the multi-sort feature is loaded and only carries a single field. The `serverSide` feature is the supported path and works with both single- and multi-column sort.
:::

### React Query Integration

If your app already uses [TanStack Query](https://tanstack.com/query/latest), one
useful pairing is to back `ServerSidePlugin` with React Query's request cache.
Each block the grid asks for becomes a query keyed by the request shape
(`startNode`, `endNode`, `sortModel`, `filterModel`) — so scrolling back to a
previously fetched range is served from cache instead of re-hitting the API,
and you get retries, in-flight deduplication, and devtools for free.

The pattern: keep `getRows` thin and delegate fetching to `queryClient.fetchQuery`
with a stable key per block.

```tsx
import '@toolbox-web/grid-react/features/server-side';
import '@toolbox-web/grid-react/features/multi-sort';
import { useMemo } from 'react';
import { useQueryClient } from '@tanstack/react-query';
import { DataGrid } from '@toolbox-web/grid-react';
import type {
  GetRowsParams,
  GetRowsResult,
  ServerSideDataSource,
} from '@toolbox-web/grid/plugins/server-side';

async function fetchEmployeeBlock(
  params: GetRowsParams,
): Promise<GetRowsResult<Employee>> {
  const search = new URLSearchParams({
    from: String(params.startNode),
    to: String(params.endNode),
  });
  if (params.sortModel?.length) {
    search.set('sort', params.sortModel.map((s) => `${s.field}:${s.direction}`).join(','));
  }
  if (params.filterModel) search.set('filter', JSON.stringify(params.filterModel));
  const response = await fetch(`/api/employees?${search}`, { signal: params.signal });
  return response.json();
}

function ServerSideGrid() {
  const queryClient = useQueryClient();

  const dataSource = useMemo<ServerSideDataSource<Employee>>(() => ({
    // Each block becomes a cached query — React Query dedupes in-flight
    // requests, retries failed ones, and serves repeated scrolls from cache.
    getRows: (params) =>
      queryClient.fetchQuery({
        queryKey: [
          'employees',
          params.startNode,
          params.endNode,
          params.sortModel,
          params.filterModel,
        ],
        queryFn: ({ signal }) => fetchEmployeeBlock({ ...params, signal }),
        staleTime: 60_000,
      }),
  }), [queryClient]);

  return (
    <DataGrid
      columns={columns}
      multiSort
      serverSide={{ dataSource, pageSize: 100 }}
    />
  );
}
```

:::tip
When the user mutates a row (commit, paste, etc.), invalidate the query to
trigger a refresh: `queryClient.invalidateQueries({ queryKey: ['employees'] })`.
The grid will re-request the affected blocks on next scroll.
:::

## Dynamic Row Updates

```tsx
import { useState, useCallback } from 'react';
import { DataGrid } from '@toolbox-web/grid-react';

function EmployeeGrid() {
  const [employees, setEmployees] = useState<Employee[]>(initialData);

  const handleAdd = useCallback(() => {
    setEmployees(prev => [
      ...prev,
      { id: Date.now(), name: 'New Employee', department: '', salary: 50000 },
    ]);
  }, []);

  const handleDelete = useCallback(() => {
    // Remove first row as example
    setEmployees(prev => prev.slice(1));
  }, []);

  return (
    <div>
      <button onClick={handleAdd}>Add</button>
      <button onClick={handleDelete}>Remove First</button>
      <DataGrid rows={employees} columns={columns} />
    </div>
  );
}
```

## Performance Tips

### Memoize Config and Columns

```tsx
// ✅ Good: Memoized — stable reference
const config = useMemo<GridConfig<Employee>>(() => ({
  columns: [/* ... */],
}), []);

// ❌ Bad: Creates new config every render
const config: GridConfig<Employee> = { columns: [/* ... */] };
```

### Use `React.memo` for Cell Components

```tsx
const StatusBadge = React.memo(function StatusBadge({ status }: { status: string }) {
  return <span className={`badge badge--${status}`}>{status}</span>;
});
```

## Troubleshooting

### Feature prop not working

Ensure you imported the feature side-effect:

```tsx
// ❌ This won't work
<DataGrid selection="range" />

// ✅ Import the feature first
import '@toolbox-web/grid-react/features/selection';
<DataGrid selection="range" />
```

### Config object recreated on every render

Wrap in `useMemo`, or use feature props directly:

```tsx
// ✅ Best: Feature props — no config object needed
<DataGrid selection="row" />

// ✅ Also good: Stable config reference
const config = useMemo(() => ({ features: { selection: true } }), []);
```

### Grid not responding to row updates

Create new arrays — the grid uses reference equality:

```tsx
// ❌ Bad: Mutating existing array
employees.push(newEmployee);
setEmployees(employees);

// ✅ Good: New array reference
setEmployees([...employees, newEmployee]);
```

## See Also

- **API Reference** — Browse all components, hooks, and types via the React API section in the sidebar
- **[Grid Plugins](/grid/plugins.md)** — All available plugins
- **[Core Features](/grid/core.md)** — Variable row heights, events, column config
- **[Common Patterns](/grid/guides/common-patterns.md)** — Reusable recipes


# Angular Integration

> Install and configure @toolbox-web/grid-angular — feature inputs, renderers, editors, events, inject functions, and Angular-specific patterns.

The `@toolbox-web/grid-angular` package provides Angular integration for the `<tbw-grid>` data grid component.

:::note[Where to find feature docs]
This page covers Angular-specific setup and APIs (feature inputs, inject functions, Angular directives). Core grid features and plugins — cell renderers, editors, events, master-detail, sorting, filtering, selection, etc. — are documented on the [Core](/grid/core.md) and [Plugins](/grid/plugins.md) pages, each with an Angular tab and runnable demos.
:::

## Compatibility

| Angular version | Support level |
| --------------- | ------------- |
| 21              | **Tested** — used in demos and CI |
| 20              | **Tested** |
| 17 – 19         | Supported (minimum peer dependency) |
| &lt; 17         | Not supported — adapter uses `input()` / `output()` signal APIs |

## Installation

#### npm

  ```bash
  npm install @toolbox-web/grid @toolbox-web/grid-angular
  ```

#### yarn

  ```bash
  yarn add @toolbox-web/grid @toolbox-web/grid-angular
  ```

#### pnpm

  ```bash
  pnpm add @toolbox-web/grid @toolbox-web/grid-angular
  ```

#### bun

  ```bash
  bun add @toolbox-web/grid @toolbox-web/grid-angular
  ```

## Setup

No bootstrap step is required. Importing `@toolbox-web/grid-angular` (or any of its `features/*` entries) registers the `<tbw-grid>` custom element as a side effect. Each feature is enabled per-component by importing its directive — see [Three Ways to Configure Features](#three-ways-to-configure-features) below.

```typescript
// Optional: if you also want to use <tbw-grid> in plain HTML templates
// outside an Angular component (rare), add this once in main.ts:
import '@toolbox-web/grid';
```

## Three Ways to Configure Features

You can enable plugins on `<tbw-grid>` with one of three patterns. Pick whichever fits the component — they can be mixed.

| Pattern | Best for | v2 status |
|---------|----------|-----------|
| **`gridConfig.features`** (object literal) | Configuration-driven apps; the entire grid setup lives in one object | ✅ Unchanged — fully supported |
| **Per-feature directive** (e.g. `GridFilteringDirective`) | Template-driven apps that want signal inputs/outputs **and** the smallest bundle | ✅ **Recommended** — the future-proof path |
| **Inputs/outputs on `Grid`** (e.g. `[filtering]`, `(filterChange)`) | v1.x apps already on this style | ⚠️ **Deprecated** — bindings remain in v1.x for compatibility but will be removed in v2.0 |

> **`gridConfig` users are not affected by the v2 cleanup** — only consumers binding feature inputs directly on `<tbw-grid>` need to switch to per-feature directives before v2.

### Recommended: Per-Feature Directives

Each feature ships its own attribute-selector directive (`GridFilteringDirective`, `GridSelectionDirective`, …) from its secondary entry. Add the directive to the component's `imports` and bind exactly the same `[input]` / `(output)` you used before:

```typescript
import { Component } from '@angular/core';
import { Grid } from '@toolbox-web/grid-angular';
import { GridFilteringDirective } from '@toolbox-web/grid-angular/features/filtering';
import { GridSelectionDirective } from '@toolbox-web/grid-angular/features/selection';

@Component({
  imports: [Grid, GridFilteringDirective, GridSelectionDirective],
  template: `
    <tbw-grid
      [rows]="rows"
      [filtering]="true"
      (filterChange)="onFilter($event)"
      [selection]="'range'"
    />
  `,
})
export class MyGrid {/* … */}
```

**Why this is the preferred path:**

- **Tree-shakeable typed surface** — the feature's `input()` / `output()` definitions ship inside the feature's own bundle. Apps that don't import the directive don't pay for its compiled metadata in the core bundle.
- **Compile-time safety** — Angular errors with `Can't bind to 'filtering' since it isn't a known property of 'tbw-grid'` if you forget the directive (stronger than React/Vue, which silently drop unknown props).
- **Same bindings, same demos** — the directive's selector matches the existing attributes (`tbw-grid[filtering], tbw-grid[filterChange]`), so migrating from the deprecated style is a one-line `imports` addition per feature with **zero template changes**.

### Legacy: Inputs/Outputs on `Grid` (deprecated)

The v1.x style — declaring `[filtering]`, `(filterChange)`, etc. directly on the `Grid` directive without importing a per-feature directive — still works for the entire v1.x line but is `@deprecated` in JSDoc. v2.0 will remove these bindings from `Grid`, at which point a one-line directive import per feature is the migration.

## Basic Usage

The simplest way to use the grid is with the `Grid` directive and per-feature directives:

```typescript
import { Component } from '@angular/core';
import { Grid } from '@toolbox-web/grid-angular';
import { GridSelectionDirective } from '@toolbox-web/grid-angular/features/selection';
import { GridEditingDirective } from '@toolbox-web/grid-angular/features/editing';
import { GridMultiSortDirective } from '@toolbox-web/grid-angular/features/multi-sort';
import { GridFilteringDirective } from '@toolbox-web/grid-angular/features/filtering';
import type { ColumnConfig } from '@toolbox-web/grid';

interface Employee {
  id: number;
  name: string;
  department: string;
  salary: number;
}

@Component({
  selector: 'app-employee-grid',
  imports: [Grid, GridSelectionDirective, GridEditingDirective, GridMultiSortDirective, GridFilteringDirective],
  template: `
    <tbw-grid
      [rows]="employees"
      [columns]="columns"
      [selection]="'range'"
      [editing]="'dblclick'"
      [multiSort]="true"
      [filtering]="{ debounceMs: 200 }"
      style="height: 400px; display: block;"
    />
  `,
})
export class EmployeeGridComponent {
  employees: Employee[] = [
    { id: 1, name: 'Alice', department: 'Engineering', salary: 95000 },
    { id: 2, name: 'Bob', department: 'Marketing', salary: 75000 },
    { id: 3, name: 'Charlie', department: 'Sales', salary: 85000 },
  ];

  columns: ColumnConfig<Employee>[] = [
    { field: 'id', header: 'ID', type: 'number', width: 70 },
    { field: 'name', header: 'Name', editable: true, sortable: true },
    { field: 'department', header: 'Department', editable: true, sortable: true },
    { field: 'salary', header: 'Salary', type: 'number', format: (v: number) => '$' + v.toLocaleString() },
  ];
}
```

## Feature Input Reference

Each feature exposes an input + (optional) output. The recommended way to use them is to import the matching **per-feature directive** alongside `Grid` (left column). The same `[input]` / `(output)` bindings are also accepted directly on `Grid` in v1.x for backward compatibility, but those bindings on `Grid` are `@deprecated` and will be removed in v2.0 — see the [Grid directive API](/grid/angular/api/directives/grid.md).

| Per-Feature Directive (recommended) | Input | Feature Import | Description |
|-------------------------------------|-------|----------------|-------------|
| [`GridSelectionDirective`](/grid/angular/api/directives/gridselectiondirective.md) | `[selection]` | `features/selection` | Cell, row, or range selection |
| [`GridEditingDirective`](/grid/angular/api/directives/grideditingdirective.md) | `[editing]` | `features/editing` | Inline cell editing |
| [`GridMultiSortDirective`](/grid/angular/api/directives/gridmultisortdirective.md) | `[multiSort]` | `features/multi-sort` | Multi-column sorting |
| [`GridFilteringDirective`](/grid/angular/api/directives/gridfilteringdirective.md) | `[filtering]` | `features/filtering` | Column filtering |
| [`GridClipboardDirective`](/grid/angular/api/directives/gridclipboarddirective.md) | `[clipboard]` | `features/clipboard` | Copy/paste support |
| [`GridContextMenuDirective`](/grid/angular/api/directives/gridcontextmenudirective.md) | `[contextMenu]` | `features/context-menu` | Right-click context menu |
| [`GridReorderColumnsDirective`](/grid/angular/api/directives/gridreordercolumnsdirective.md) | `[reorderColumns]` | `features/reorder-columns` | Column drag-to-reorder |
| [`GridVisibilityDirective`](/grid/angular/api/directives/gridvisibilitydirective.md) | `[visibility]` | `features/visibility` | Column visibility panel |
| [`GridPinnedColumnsDirective`](/grid/angular/api/directives/gridpinnedcolumnsdirective.md) | `[pinnedColumns]` | `features/pinned-columns` | Sticky left/right columns |
| [`GridPinnedRowsDirective`](/grid/angular/api/directives/gridpinnedrowsdirective.md) | `[pinnedRows]` | `features/pinned-rows` | Sticky top/bottom rows |
| [`GridGroupingColumnsDirective`](/grid/angular/api/directives/gridgroupingcolumnsdirective.md) | `[groupingColumns]` | `features/grouping-columns` | Multi-level column headers |
| [`GridGroupingRowsDirective`](/grid/angular/api/directives/gridgroupingrowsdirective.md) | `[groupingRows]` | `features/grouping-rows` | Row grouping |
| [`GridColumnVirtualizationDirective`](/grid/angular/api/directives/gridcolumnvirtualizationdirective.md) | `[columnVirtualization]` | `features/column-virtualization` | Virtualize columns for wide grids |
| [`GridRowDragDropDirective`](/grid/angular/api/directives/gridrowdragdropdirective.md) | `[rowDragDrop]` / `[reorderRows]` | `features/row-drag-drop` | Row drag-and-drop (within and across grids) |
| [`GridTreeDirective`](/grid/angular/api/directives/gridtreedirective.md) | `[tree]` | `features/tree` | Hierarchical tree view |
| [`GridMasterDetailDirective`](/grid/angular/api/directives/gridmasterdetaildirective.md) | `[masterDetail]` | `features/master-detail` | Expandable detail rows |
| [`GridResponsiveDirective`](/grid/angular/api/directives/gridresponsivedirective.md) | `[responsive]` | `features/responsive` | Card layout for narrow viewports |
| [`GridTooltipDirective`](/grid/angular/api/directives/gridtooltipdirective.md) | `[tooltip]` | `features/tooltip` | Cell / header tooltips |
| [`GridUndoRedoDirective`](/grid/angular/api/directives/gridundoredodirective.md) | `[undoRedo]` | `features/undo-redo` | Edit undo/redo |
| [`GridExportDirective`](/grid/angular/api/directives/gridexportdirective.md) | `[export]` | `features/export` | CSV/Excel export |
| [`GridPrintDirective`](/grid/angular/api/directives/gridprintdirective.md) | `[print]` | `features/print` | Print support |
| [`GridPivotDirective`](/grid/angular/api/directives/gridpivotdirective.md) | `[pivot]` | `features/pivot` | Pivot table functionality |
| [`GridServerSideDirective`](/grid/angular/api/directives/gridserversidedirective.md) | `[serverSide]` | `features/server-side` | Server-side data loading |
| [`GridStickyRowsDirective`](/grid/angular/api/directives/gridstickyrowsdirective.md) | `[stickyRows]` | `features/sticky-rows` | Pin selected data rows below the header on scroll |

**Core Config Inputs (no feature import needed):**

| Input | Type | Description |
|-------|------|-------------|
| `[rows]` | `T[]` | Row data — omit when using `[serverSide]` |
| `[columns]` | [`ColumnConfig`](/grid/api/core/interfaces/columnconfig.md)`[]` | Column definitions (alternative to `gridConfig.columns`) |
| `[gridConfig]` | [`GridConfig`](/grid/api/core/interfaces/gridconfig.md) | Full grid configuration object |
| `[loading]` | `boolean` | Show the grid's loading overlay |
| `[fitMode]` | `FitMode` | Column-fit strategy (`'auto'`, `'fill'`, `'fill-rest'`, etc.) |
| `[customStyles]` | `string` | CSS injected into the grid — useful for custom renderer/editor styling |
| `[sortable]` | `boolean` | Grid-wide sorting toggle (default: true) |
| `[filterable]` | `boolean` | Grid-wide filtering toggle (default: true). Requires FilteringPlugin. |
| `[selectable]` | `boolean` | Grid-wide selection toggle (default: true). Requires SelectionPlugin. |

## Programmatic Grid Access

Use [`injectGrid()`](/grid/angular/api/utilities/injectgrid.md) for programmatic access to the grid. It provides a reactive API via signals — see [`InjectGridReturn`](/grid/angular/api/types/injectgridreturn.md) for the full return shape:

```typescript
import { Component, effect } from '@angular/core';
import { Grid, injectGrid } from '@toolbox-web/grid-angular';

@Component({
  selector: 'app-employee-grid',
  imports: [Grid],
  template: `
    <tbw-grid [rows]="employees" [columns]="columns"></tbw-grid>

    <p>Grid ready: {{ grid.isReady() }}</p>
    <button (click)="refresh()">Force Layout</button>
  `,
})
export class EmployeeGridComponent {
  grid = injectGrid();

  employees = [/* ... */];
  columns = [/* ... */];

  constructor() {
    effect(() => {
      if (this.grid.isReady()) {
        console.log('Grid element:', this.grid.element());
      }
    });
  }

  refresh() {
    this.grid.forceLayout();
  }
}
```

## Feature-Scoped Inject Functions

Feature imports export **scoped inject functions** for type-safe programmatic access to plugin functionality — no direct plugin references needed.

```typescript
import { GridExportDirective } from '@toolbox-web/grid-angular/features/export';
import { injectGridExport } from '@toolbox-web/grid-angular/features/export';
import { Component } from '@angular/core';
import { Grid } from '@toolbox-web/grid-angular';

@Component({
  imports: [Grid, GridExportDirective],
  template: `
    <div class="toolbar">
      <button (click)="exportCsv()" [disabled]="gridExport.isExporting()">Export CSV</button>
    </div>
    <tbw-grid [rows]="employees" [columns]="columns" [export]="true" />
  `,
})
export class ExportGridComponent {
  employees = [/* ... */];
  columns = [/* ... */];
  gridExport = injectGridExport();

  exportCsv() {
    this.gridExport.exportToCsv('employees.csv');
  }
}
```

### Available Inject Functions

See the **API Reference > Inject Functions** section for detailed method signatures, return types, and examples.

All inject functions accept an optional `selector` parameter (defaults to `'tbw-grid'`) to target a specific grid when a component contains multiple grids:

```typescript
// Target a specific grid by CSS selector
gridSelection = injectGridSelection('tbw-grid.primary');
gridExport = injectGridExport('#secondary-grid');
```

| Function | Import | Key Methods |
|----------|--------|-------------|
| [`injectGrid()`](/grid/angular/api/utilities/injectgrid.md) | `@toolbox-web/grid-angular` | `element`, `isReady`, `config`, `forceLayout`, `toggleGroup`, `registerStyles`, `visibleColumns` |
| [`injectGridSelection()`](/grid/angular/api/features/injectgridselection.md) | `features/selection` | `selectAll`, `clearSelection`, `getSelection`, `selectedRowIndices` (Signal) |
| [`injectGridFiltering()`](/grid/angular/api/features/injectgridfiltering.md) | `features/filtering` | `setFilter`, `clearAllFilters`, `getFilters`, `getFilteredRowCount` |
| [`injectGridExport()`](/grid/angular/api/features/injectgridexport.md) | `features/export` | `exportToCsv`, `exportToExcel`, `exportToJson`, `isExporting` |
| [`injectGridPrint()`](/grid/angular/api/features/injectgridprint.md) | `features/print` | `print`, `isPrinting` |
| [`injectGridUndoRedo()`](/grid/angular/api/features/injectgridundoredo.md) | `features/undo-redo` | `undo`, `redo`, `canUndo` (Signal), `canRedo` (Signal) |

### Signal-Based Selection Example

```typescript
import { Component, computed } from '@angular/core';
import { Grid } from '@toolbox-web/grid-angular';
import { injectGridSelection } from '@toolbox-web/grid-angular/features/selection';

@Component({
  selector: 'app-employee-grid',
  imports: [Grid],
  template: `
    <tbw-grid [rows]="employees" [gridConfig]="gridConfig"></tbw-grid>
    <p>Selected: {{ selectedCount() }}</p>
    <button (click)="gridSelection.selectAll()">Select All</button>
    <button (click)="gridSelection.clearSelection()">Clear</button>
  `,
})
export class EmployeeGridComponent {
  gridSelection = injectGridSelection();
  selectedCount = computed(() => this.gridSelection.selectedRowIndices().length);

  gridConfig = {
    features: { selection: { mode: 'row', checkbox: true } },
  };
}
```

## Type-Level Defaults

Register application-wide renderers and editors for specific data types using [`provideGridTypeDefaults()`](/grid/angular/api/utilities/providegridtypedefaults.md):

```typescript
// app.config.ts
import { ApplicationConfig } from '@angular/core';
import { provideGridTypeDefaults } from '@toolbox-web/grid-angular';
import { CurrencyRendererComponent, DateRendererComponent } from './renderers';

export const appConfig: ApplicationConfig = {
  providers: [
    provideGridTypeDefaults({
      currency: { renderer: CurrencyRendererComponent },
      date: { renderer: DateRendererComponent },
    }),
  ],
};
```

For dynamic registration at runtime, inject [`GridTypeRegistry`](/grid/angular/api/utilities/gridtyperegistry.md):

```typescript
import { inject } from '@angular/core';
import { GridTypeRegistry } from '@toolbox-web/grid-angular';

export class AppComponent {
  private registry = inject(GridTypeRegistry);

  ngOnInit() {
    this.registry.register('currency', {
      renderer: CurrencyCellComponent,
    });
  }
}
```

## Custom Icons

The grid supports two complementary ways to customize icons — see the [Theming Guide → Icon Customization](/grid/guides/theming.md#icon-customization) for both the CSS and JavaScript approaches:

- **CSS variables** (`--tbw-icon-*`) — preferred for themes and static customization; no JavaScript needed.
- **`gridConfig.icons`** — for dynamic icons, icon libraries, or `HTMLElement` instances; takes precedence over CSS.

[`provideGridIcons()`](/grid/angular/api/utilities/providegridicons.md) is the Angular DI wrapper for the JS path — it injects `icons` into `gridConfig.icons` for every grid in the application:

```typescript
// app.config.ts
import { provideGridIcons } from '@toolbox-web/grid-angular';

export const appConfig = {
  providers: [
    provideGridIcons({
      sortAsc: '<svg>...</svg>',
      sortDesc: '<svg>...</svg>',
      filter: '<svg>...</svg>',
    }),
  ],
};
```

## Manual Plugin Instantiation

While feature inputs are recommended, you can instantiate plugins manually for custom configurations or third-party plugins:

```typescript
import { Component } from '@angular/core';
import { Grid } from '@toolbox-web/grid-angular';
import { SelectionPlugin, EditingPlugin, ClipboardPlugin } from '@toolbox-web/grid/all';
import type { GridConfig } from '@toolbox-web/grid';

@Component({
  selector: 'app-employee-grid',
  imports: [Grid],
  template: `<tbw-grid [rows]="employees" [gridConfig]="gridConfig"></tbw-grid>`,
})
export class EmployeeGridComponent {
  employees = [/* ... */];

  gridConfig: GridConfig = {
    columns: [
      { field: 'id', header: 'ID' },
      { field: 'name', header: 'Name', editable: true },
    ],
    plugins: [
      new SelectionPlugin({ mode: 'range', checkbox: true }),
      new EditingPlugin({ editOn: 'dblclick' }),
      new ClipboardPlugin({ includeHeaders: true }),
    ],
  };
}
```

Feature inputs and manual plugins can be mixed — the grid merges them, with manual plugins added first.

## Angular-Specific Directives

### Custom Tool Panels

Use the [`GridToolPanel`](/grid/angular/api/directives/gridtoolpanel.md) directive to declare a custom sidebar panel inline. Place a `<tbw-grid-tool-panel>` element inside the grid with an `<ng-template>` for its content — the template receives the grid element as its implicit context (and as `let-grid`):

```typescript
import { Component } from '@angular/core';
import { Grid, GridToolPanel } from '@toolbox-web/grid-angular';

@Component({
  imports: [Grid, GridToolPanel],
  template: `
    <tbw-grid [rows]="employees" [columns]="columns">
      <tbw-grid-tool-panel
        id="stats"
        title="Statistics"
        icon="📊"
        [order]="10"
      >
        <ng-template let-grid>
          <div class="stats-panel">
            <h3>Statistics</h3>
            <p>Total rows: {{ employees.length }}</p>
          </div>
        </ng-template>
      </tbw-grid-tool-panel>
    </tbw-grid>
  `,
})
export class EmployeeGridComponent {
  employees = [/* ... */];
  columns = [/* ... */];
}
```

**Inputs:** `id` (required), `title` (required), `icon`, `tooltip`, `order` (default `100`, lower = first).

### Header & Toolbar Content

Inject Angular components into the grid's shell header (left zone) or toolbar (right zone) via the [`GridHeaderContent`](/grid/angular/api/directives/gridheadercontent.md) and [`GridToolbarContent`](/grid/angular/api/directives/gridtoolbarcontent.md) directives. These wrap the imperative `registerHeaderContent` / `registerToolbarContent` APIs and mount an `<ng-template>` so projected components retain full DI, change detection, and signal reactivity.

```typescript
import { Component, signal } from '@angular/core';
import { Grid, GridHeaderContent, GridToolbarContent } from '@toolbox-web/grid-angular';

@Component({
  imports: [Grid, GridHeaderContent, GridToolbarContent, HeaderNavComponent, ToolbarNavComponent],
  template: `
    <tbw-grid [rows]="rows()" [gridConfig]="config()">
      <tbw-grid-header-content id="calendar-nav" [order]="0">
        <ng-template>
          <app-header-nav [year]="year()" (yearChange)="onYearChange($event)" />
        </ng-template>
      </tbw-grid-header-content>
      <tbw-grid-toolbar-content id="calendar-buttons" [order]="0">
        <ng-template>
          <app-toolbar-nav (previous)="prev()" (today)="today()" (next)="next()" />
        </ng-template>
      </tbw-grid-toolbar-content>
    </tbw-grid>
  `,
})
export class CalendarGridComponent {
  year = signal(new Date().getFullYear());
  onYearChange(year: number) { this.year.set(year); }
}
```

**Inputs:** `id` (optional — auto-generated if omitted), `order` (default `100`, lower = first). Template bindings re-evaluate via Angular change detection without re-registering with the grid.

## Server-Side Data Loading

The full data-source contract, sort/filter modes, prefetching, cancellation and live-update patterns are documented on the [Server-Side plugin](/grid/plugins/server-side.md) page (it has runnable demos and an Angular tab in every example). The two Angular-specific points worth calling out here:

1. **Use the per-feature directive (recommended).** Add [`GridServerSideDirective`](/grid/angular/api/directives/gridserversidedirective.md) to your component's `imports` if you want to bind via `[serverSide]="…"` on `<tbw-grid>`. If you configure server-side through `[gridConfig]="{ features: { serverSide: … } }"` instead, no extra directive is needed — the deprecated `[serverSide]` binding on `Grid` itself still works in v1.x but will be removed in v2.0.
2. **Return the `HttpClient` `Observable` directly from `getRows`.** No `firstValueFrom`, no manual `takeUntil`. The grid subscribes once and calls `unsubscribe()` when the request is superseded (sort change, fast scrolling, `refresh()`); `HttpClient` cancels the underlying XHR in response, which is the only correct way to avoid stale-buffer races.

```typescript
import { Component, inject } from '@angular/core';
import { HttpClient, HttpParams } from '@angular/common/http';
import { map } from 'rxjs/operators';
import { Grid } from '@toolbox-web/grid-angular';
import { GridServerSideDirective } from '@toolbox-web/grid-angular/features/server-side';
import type { GridConfig } from '@toolbox-web/grid';
import type { ServerSideDataSource } from '@toolbox-web/grid/plugins/server-side';

@Component({
  selector: 'app-employee-grid',
  imports: [Grid, GridServerSideDirective],
  template: `<tbw-grid [gridConfig]="gridConfig" style="height: 400px; display: block;"></tbw-grid>`,
})
export class EmployeeGridComponent {
  private http = inject(HttpClient);

  private dataSource: ServerSideDataSource<Employee> = {
    getRows: (params) => {
      const httpParams = new HttpParams()
        .set('offset', params.startNode)
        .set('limit', params.endNode - params.startNode);
      return this.http
        .get<{ items: Employee[]; total: number }>('/api/employees', { params: httpParams })
        .pipe(map((data) => ({ rows: data.items, totalNodeCount: data.total })));
    },
  };

  gridConfig: GridConfig<Employee> = {
    columns: [/* … */],
    features: { serverSide: { dataSource: this.dataSource } },
  };
}
```

> **Caching:** Angular has no built-in equivalent to TanStack Query's request cache. If you need cross-component caching, deduplication or `staleTime`, wrap the `HttpClient` call in your own service (e.g. with `shareReplay`), or evaluate [`@tanstack/angular-query-experimental`](https://tanstack.com/query/latest/docs/framework/angular/overview) — note the `experimental` tag.

## Dynamic Row Updates

```typescript
import { Component, signal } from '@angular/core';
import { Grid } from '@toolbox-web/grid-angular';

@Component({
  imports: [Grid],
  template: `
    <tbw-grid [rows]="employees()" [columns]="columns"></tbw-grid>
    <button (click)="addEmployee()">Add</button>
    <button (click)="removeFirst()">Remove First</button>
  `,
})
export class EmployeeGridComponent {
  employees = signal([
    { id: 1, name: 'Alice', department: 'Engineering' },
    { id: 2, name: 'Bob', department: 'Design' },
  ]);

  columns = [
    { field: 'id', header: 'ID' },
    { field: 'name', header: 'Name' },
    { field: 'department', header: 'Department' },
  ];

  private nextId = 3;

  addEmployee() {
    this.employees.update(rows => [
      ...rows,
      { id: this.nextId++, name: 'New Employee', department: 'TBD' },
    ]);
  }

  removeFirst() {
    this.employees.update(rows => rows.slice(1));
  }
}
```

> **Tip**: Use Angular signals for rows. The grid detects the new array reference and re-renders efficiently.

## Performance Tips

### OnPush Change Detection

```typescript
@Component({
  changeDetection: ChangeDetectionStrategy.OnPush,
  // ...
})
export class EmployeeGridComponent { }
```

### Define Columns Once

```typescript
// ✅ Good — assigned once
readonly columns: ColumnConfig[] = [
  { field: 'id', header: 'ID' },
  { field: 'name', header: 'Name' },
];

// ❌ Bad — getter creates new array every check
get columns() {
  return [{ field: 'id', header: 'ID' }, { field: 'name', header: 'Name' }];
}
```

## Troubleshooting

### Feature input not working

Ensure you imported the feature side-effect in your `main.ts`:

```typescript
// main.ts — must be imported before bootstrap
import { GridSelectionDirective } from '@toolbox-web/grid-angular/features/selection';
```

### "is not a known element" errors

The `@toolbox-web/grid-angular` adapter provides directives that register all `<tbw-*>` elements with Angular's template compiler — no `CUSTOM_ELEMENTS_SCHEMA` needed. Import the directive that matches the element used in your template:

```typescript
import { Grid, TbwGridColumn } from '@toolbox-web/grid-angular';

@Component({
  imports: [Grid, TbwGridColumn], // Grid → <tbw-grid>, TbwGridColumn → <tbw-grid-column>
  // ...
})
```

### Grid not rendering

The grid needs a defined height for virtualization. See [Troubleshooting → Height & Virtualization](/grid/guides/troubleshooting.md#height--virtualization) for solutions.

### Row updates not reflected

The grid detects updates via reference equality. Always assign a new array:

```typescript
// ✅ New reference — grid re-renders
this.employees.update(rows => [...rows, newRow]);

// ❌ Same reference — grid won't detect change
this.employees().push(newRow);
```

## See Also

- **[Base Classes](/grid/angular/base-classes.md)** — `BaseOverlayEditor`, `BaseGridEditorCVA`, `BaseFilterPanel`
- **[Reactive Forms](/grid/angular/reactive-forms.md)** — `FormArray` integration with `GridFormArray` and `GridLazyForm`
- **API Reference** — Browse all directives, utilities, and types via the Angular API section in the sidebar
- **[Grid Plugins](/grid/plugins.md)** — All available plugins
- **[Core Features](/grid/core.md)** — Variable row heights, events, column config
